Index: kdeui/klistview.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/klistview.cpp,v
retrieving revision 1.194
diff -d -u -p -r1.194 klistview.cpp
--- kdeui/klistview.cpp	25 Feb 2003 17:51:11 -0000	1.194
+++ kdeui/klistview.cpp	5 Mar 2003 05:57:50 -0000
@@ -545,20 +545,20 @@ void KListView::slotAutoSelect()
     setFocus();
 
 #ifdef Q_WS_X11
-  // FIXME(E): Implement for Qt Embedded
   Window root;
   Window child;
   int root_x, root_y, win_x, win_y;
   uint keybstate;
   XQueryPointer( qt_xdisplay(), qt_xrootwin(), &root, &child,
                                  &root_x, &root_y, &win_x, &win_y, &keybstate );
+#else
+      //FIXME: Implement (QWS & MAC) 
 #endif
 
   QListViewItem* previousItem = currentItem();
   setCurrentItem( d->pCurrentItem );
 
-#ifndef Q_WS_QWS
-  // FIXME(E): Implement for Qt Embedded
+#ifdef Q_WS_X11
   if( d->pCurrentItem ) {
     //Shift pressed?
     if( (keybstate & ShiftMask) ) {
@@ -612,6 +612,8 @@ void KListView::slotAutoSelect()
   }
   else
     kdDebug() << "KListView::slotAutoSelect: That´s not supposed to happen!!!!" << endl;
+#else
+      //FIXME: Implement (QWS & MAC) 
 #endif
 }
 
@@ -637,8 +639,7 @@ void KListView::emitExecute( QListViewIt
         }
         else
         {
-#ifndef Q_WS_QWS
-	    // FIXME(E): Implement for Qt Embedded
+#ifdef Q_WS_X11
             Window root;
             Window child;
             int root_x, root_y, win_x, win_y;
@@ -653,6 +654,8 @@ void KListView::emitExecute( QListViewIt
                 emit executed( item );
                 emit executed( item, pos, c );
             }
+#else
+	    //FIXME: Implement (QWS & MAC) 
 #endif
         }
     }
Index: kdeui/kmainwindow.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kmainwindow.cpp,v
retrieving revision 1.91
diff -d -u -p -r1.91 kmainwindow.cpp
--- kdeui/kmainwindow.cpp	22 Jan 2003 13:12:05 -0000	1.91
+++ kdeui/kmainwindow.cpp	5 Mar 2003 05:57:52 -0000
@@ -44,8 +44,8 @@
 #include <klocale.h>
 #include <kstandarddirs.h>
 #include <kstaticdeleter.h>
-#ifndef Q_WS_QWS
-#include <netwm.h>
+#ifdef Q_WS_X11
+# include <netwm.h>
 #endif
 
 #include <stdlib.h>
@@ -254,8 +254,7 @@ void KMainWindow::parseGeometry(bool par
     assert ( !kapp->geometryArgument().isNull() );
     assert ( d->care_about_geometry );
 
-#ifndef Q_WS_QWS
-    // FIXME: (E) Implement something similar for Qt Embedded (or decide we don't need it)
+#ifdef Q_WS_X11
     int x, y;
     int w, h;
     int m = XParseGeometry( kapp->geometryArgument().latin1(), &x, &y, (unsigned int*)&w, (unsigned int*)&h);
@@ -282,6 +281,8 @@ void KMainWindow::parseGeometry(bool par
             y = KApplication::desktop()->height() + y - h;
         move(x, y);
     }
+#else
+      //FIXME: Implement (QWS & MAC) 
 #endif
 }
 
@@ -472,7 +473,7 @@ void KMainWindow::setCaption( const QStr
 void KMainWindow::setPlainCaption( const QString &caption )
 {
     QMainWindow::setCaption( caption );
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
     NETWinInfo info( qt_xdisplay(), winId(), qt_xrootwin(), 0 );
     info.setName( caption.utf8().data() );
 #endif
Index: kdeui/kmenubar.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kmenubar.cpp,v
retrieving revision 1.164
diff -d -u -p -r1.164 kmenubar.cpp
--- kdeui/kmenubar.cpp	5 Feb 2003 12:46:04 -0000	1.164
+++ kdeui/kmenubar.cpp	5 Mar 2003 05:57:52 -0000
@@ -37,7 +37,7 @@
 #include <kwinmodule.h>
 #include <kglobal.h>
 
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
 #include <X11/Xatom.h>
@@ -122,8 +122,10 @@ void KMenuBar::setTopLevelMenuInternal(b
       d->frameStyle = frameStyle();
       removeEventFilter( topLevelWidget() );
       reparent( parentWidget(), WType_TopLevel | WType_Dialog | WStyle_NoBorder, QPoint(0,0), false );
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11
       KWin::setType( winId(), NET::TopMenu );
+#else
+      //FIXME (QWS & MAC)
 #endif
       setFrameStyle( MenuBarPanel );
       installEventFilter( parentWidget()->topLevelWidget() );
@@ -212,11 +214,13 @@ void KMenuBar::updateKMenubarSize()
             QApplication::desktop()->screenNumber(QPoint(0,0)) );
         QRect area = QApplication::desktop()->screenGeometry(screen);
         QMenuBar::setGeometry(area.left(), area.top()-frameWidth()-2, area.width(), heightForWidth( area.width() ) );
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
         int strut_height = height()-frameWidth()-2;
         if( strut_height < 0 )
             strut_height = 0;
         KWin::setStrut( winId(), 0, 0, strut_height, 0 );
+#else
+	//FIXME: Implement (QWS & MAC) 
 #endif
     }
 }
Index: kdeui/kpassivepopup.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kpassivepopup.cpp,v
retrieving revision 1.21
diff -d -u -p -r1.21 kpassivepopup.cpp
--- kdeui/kpassivepopup.cpp	20 Feb 2003 06:39:20 -0000	1.21
+++ kdeui/kpassivepopup.cpp	5 Mar 2003 05:57:52 -0000
@@ -162,6 +162,7 @@ void KPassivePopup::hideEvent( QHideEven
 
 QRect KPassivePopup::defaultArea() const
 {
+#ifdef Q_WS_X11
     NETRootInfo info( qt_xdisplay(),
                       NET::NumberOfDesktops |
                       NET::CurrentDesktop |
@@ -172,17 +173,20 @@ QRect KPassivePopup::defaultArea() const
     QRect r;
     r.setRect( workArea.pos.x, workArea.pos.y, 0, 0 ); // top left
     return r;
+#else
+    QPoint pt = QApplication::desktop()->availableGeometry(0).topLeft();
+    return QRect(pt, QSize(0, 0));
+#endif
 }
 
 void KPassivePopup::positionSelf()
 {
     QRect target;
 
+#ifdef Q_WS_X11
     if ( window == 0L ) {
         target = defaultArea();
-    }
-
-    else {
+    } else {
         NETWinInfo ni( qt_xdisplay(), window, qt_xrootwin(),
                        NET::WMIconGeometry | NET::WMKDESystemTrayWinFor );
 
@@ -208,7 +212,9 @@ void KPassivePopup::positionSelf()
                 }
         }
     }
-
+#else
+    target = defaultArea();
+#endif
     moveNear( target );
 }
 
Index: kdeui/kpixmapio.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kpixmapio.cpp,v
retrieving revision 1.27
diff -d -u -p -r1.27 kpixmapio.cpp
--- kdeui/kpixmapio.cpp	28 Feb 2003 19:13:14 -0000	1.27
+++ kdeui/kpixmapio.cpp	5 Mar 2003 05:57:53 -0000
@@ -27,12 +27,12 @@
 #include <kdebug.h>
 #include "kpixmapio.h"
 
-#ifndef Q_WS_QWS
-#include <X11/X.h>
-#include <X11/Xlib.h>
-#include <X11/Xutil.h>
-#ifdef HAVE_MITSHM
-#include <X11/extensions/XShm.h>
+#ifdef Q_WS_X11
+# include <X11/X.h>
+# include <X11/Xlib.h>
+# include <X11/Xutil.h>
+# ifdef HAVE_MITSHM
+# include <X11/extensions/XShm.h>
 #endif
 #ifdef __osf__
 extern "C" int XShmQueryExtension(Display *display);
@@ -50,7 +50,7 @@ struct KPixmapIOPrivate
     int threshold;
     int bpp;
     int byteorder;
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
     XImage *ximage;
 #ifdef HAVE_MITSHM
     XShmSegmentInfo *shminfo;
Index: kdeui/kprogress.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kprogress.cpp,v
retrieving revision 1.45
diff -d -u -p -r1.45 kprogress.cpp
--- kdeui/kprogress.cpp	18 Feb 2003 03:19:49 -0000	1.45
+++ kdeui/kprogress.cpp	5 Mar 2003 05:57:54 -0000
@@ -165,7 +165,9 @@ KProgressDialog::KProgressDialog(QWidget
       mShown(false),
       mMinDuration(2000)
 {
+#ifdef Q_WS_X11
     KWin::setIcons(winId(), kapp->icon(), kapp->miniIcon());
+#endif
     mShowTimer = new QTimer(this);
     
     showButton(KDialogBase::Close, false);
Index: kdeui/krootpixmap.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/krootpixmap.cpp,v
retrieving revision 1.18
diff -d -u -p -r1.18 krootpixmap.cpp
--- kdeui/krootpixmap.cpp	4 Aug 2002 14:07:53 -0000	1.18
+++ kdeui/krootpixmap.cpp	5 Mar 2003 05:57:54 -0000
@@ -15,7 +15,7 @@
 #include <qrect.h>
 #include <qimage.h>
 
-#ifndef Q_WS_QWS //FIXME
+#ifndef Q_WS_QWS
 #include <kapplication.h>
 #include <kimageeffect.h>
 #include <kpixmapio.h>
@@ -67,9 +67,13 @@ KRootPixmap::~KRootPixmap()
 
 int KRootPixmap::currentDesktop() const
 {
+#ifdef Q_WS_X11
     NETRootInfo rinfo( qt_xdisplay(), NET::CurrentDesktop );
     rinfo.activate();
     return rinfo.currentDesktop();
+#else
+    return 0;
+#endif
 }
 
 
Index: kdeui/ksharedpixmap.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/ksharedpixmap.cpp,v
retrieving revision 1.16
diff -d -u -p -r1.16 ksharedpixmap.cpp
--- kdeui/ksharedpixmap.cpp	15 Feb 2003 23:38:09 -0000	1.16
+++ kdeui/ksharedpixmap.cpp	5 Mar 2003 05:57:54 -0000
@@ -29,13 +29,14 @@
 #include <kdebug.h>
 #include <stdlib.h> // for abs
 
-#include <X11/Xlib.h>
-
+#ifdef Q_WS_X11
+# include <X11/Xlib.h>
 // Make sure to include all this X-based shit before we clean up the mess.
 // Needed for --enable-final. Not needed by this file itself!
-#include <X11/Xutil.h>
-#ifdef HAVE_MITSHM
-#include <X11/extensions/XShm.h>
+# include <X11/Xutil.h>
+# ifdef HAVE_MITSHM
+# include <X11/extensions/XShm.h>
+# endif
 #endif
 
 #include <netwm.h>
@@ -56,9 +57,11 @@
 class KSharedPixmapPrivate
 {
 public:
+#ifdef Q_WS_X11
   Atom pixmap;
   Atom target;
   Atom selection;
+#endif
   QRect rect;
 };
 
@@ -78,26 +81,33 @@ KSharedPixmap::~KSharedPixmap()
 
 void KSharedPixmap::init()
 {
+#ifdef Q_WS_X11
     d->pixmap = XInternAtom(qt_xdisplay(), "PIXMAP", false);
     QCString atom;
     atom.sprintf("target prop for window %lx", static_cast<unsigned long int>(winId()));
     d->target = XInternAtom(qt_xdisplay(), atom.data(), false);
     d->selection = None;
+#endif
 }
 
 
 bool KSharedPixmap::isAvailable(const QString & name) const
 {
+#ifdef Q_WS_X11
     QString str = QString("KDESHPIXMAP:%1").arg(name);
     Atom sel = XInternAtom(qt_xdisplay(), str.latin1(), true);
     if (sel == None)
 	return false;
     return XGetSelectionOwner(qt_xdisplay(), sel) != None;
+#else
+    return FALSE;
+#endif
 }
 
 
 bool KSharedPixmap::loadFromShared(const QString & name, const QRect & rect)
 {
+#ifdef Q_WS_X11
     if (d->selection != None)
 	// already active
 	return false;
@@ -118,9 +128,12 @@ bool KSharedPixmap::loadFromShared(const
     XConvertSelection(qt_xdisplay(), d->selection, d->pixmap, d->target,
 	    winId(), CurrentTime);
     return true;
+#else
+    return FALSE;
+#endif
 }
 
-
+#ifdef Q_WS_X11
 bool KSharedPixmap::x11Event(XEvent *event)
 {
     if (event->type != SelectionNotify)
@@ -218,6 +231,7 @@ bool KSharedPixmap::x11Event(XEvent *eve
     emit done(true);
     return true;
 }
+#endif
 
 
 #include "ksharedpixmap.moc"
Index: kdeui/ksharedpixmap.h
===================================================================
RCS file: /home/kde/kdelibs/kdeui/ksharedpixmap.h,v
retrieving revision 1.8
diff -d -u -p -r1.8 ksharedpixmap.h
--- kdeui/ksharedpixmap.h	18 Feb 2003 06:46:45 -0000	1.8
+++ kdeui/ksharedpixmap.h	5 Mar 2003 05:57:55 -0000
@@ -98,7 +98,9 @@ signals:
     void done(bool success);
 
 protected:
+#ifdef Q_WS_X11
     bool x11Event(XEvent *);
+#endif
     
 private:
     bool copy(const QString & id, const QRect & rect);
Index: kdeui/ksystemtray.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/ksystemtray.cpp,v
retrieving revision 1.23
diff -d -u -p -r1.23 ksystemtray.cpp
--- kdeui/ksystemtray.cpp	27 Dec 2002 20:11:11 -0000	1.23
+++ kdeui/ksystemtray.cpp	5 Mar 2003 05:57:55 -0000
@@ -29,7 +29,7 @@
 #include <kiconloader.h>
 
 #include <qapplication.h>
-#ifndef Q_WS_QWS
+#ifdef Q_WS_X11
 #include <X11/Xlib.h>
 #ifndef KDE_USE_FINAL
 const int XFocusOut = FocusOut;
@@ -65,10 +65,11 @@ KSystemTray::KSystemTray( QWidget* paren
     d = new KSystemTrayPrivate;
     d->actionCollection = new KActionCollection(this);
 
-#ifndef Q_WS_QWS
-    // FIXME(E): Talk with QWS
+#ifdef Q_WS_X11
     KWin::setSystemTrayWindowFor( winId(), parent?parent->topLevelWidget()->winId(): qt_xrootwin() );
     setBackgroundMode(X11ParentRelative);
+#else
+    // FIXME(E): Talk with QWS & MAC
 #endif
     hasQuit = 0;
     menu = new KPopupMenu( this );
@@ -114,8 +115,7 @@ void KSystemTray::showEvent( QShowEvent 
 
 void KSystemTray::enterEvent( QEvent* )
 {
-#ifndef Q_WS_QWS
-    // FIXME(E): Implement for Qt Embedded
+#ifdef Q_WS_X11
     if ( !qApp->focusWidget() ) {
 	XEvent ev;
 	memset(&ev, 0, sizeof(ev));
@@ -129,6 +129,8 @@ void KSystemTray::enterEvent( QEvent* )
 	qApp->x11ProcessEvent( &ev );
 	qt_x_time = time;
     }
+#else
+      //FIXME: Implement (QWS & MAC) 
 #endif
 }
 
@@ -185,6 +187,7 @@ void KSystemTray::toggleMinimizeRestore(
     if ( !pw )
 	return;
 
+#ifdef Q_WS_X11
     KWin::Info info = KWin::info( pw->winId() );
     bool visible = (info.mappingState == NET::Visible);
     if ( visible && !pw->isActiveWindow() ) // may be obscured -> raise it
@@ -201,20 +204,29 @@ void KSystemTray::toggleMinimizeRestore(
                 visible = false;
         }
     }
+#else
+    bool visible = FALSE;
+#endif
 
     if ( !visible )
     {
+#ifdef Q_WS_X11
         if ( info.mappingState != NET::Iconic )
+#endif
         {
             pw->hide(); // KWin::setOnDesktop( parentWidget()->winId(), KWin::currentDesktop() );
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11
             pw->move( info.geometry.topLeft() );
+#else
+	    //FIXME: Implement (QWS & MAC) 
 #endif
             pw->show();
-#ifndef Q_WS_QWS //FIXME
         }
+#ifdef Q_WS_X11
         KWin::deIconifyWindow( pw->winId() );
 	KWin::setActiveWindow( pw->winId() );
+#else
+	//FIXME: Implement (QWS & MAC) 
 #endif
     } else {
 	pw->hide();
Index: kdeui/kwindowinfo.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kwindowinfo.cpp,v
retrieving revision 1.3
diff -d -u -p -r1.3 kwindowinfo.cpp
--- kdeui/kwindowinfo.cpp	21 Jun 2002 13:01:22 -0000	1.3
+++ kdeui/kwindowinfo.cpp	5 Mar 2003 05:57:55 -0000
@@ -72,12 +72,13 @@ void KWindowInfo::message( const QString
 
 void KWindowInfo::permanent( const QString &text )
 {
+#ifdef Q_WS_X11
     oldMiniIcon = KWin::icon( win->winId(), 16, 16, true );
     oldIcon = KWin::icon( win->winId(), 34, 34, false );
     if ( oldIcon.isNull() )
 	oldIcon = KWin::icon( win->winId(), 32, 32, true );
-
     permanent( text, oldIcon );
+#endif
 }
 
 void KWindowInfo::permanent( const QString &text, const QPixmap &pix )
@@ -115,11 +116,14 @@ void KWindowInfo::display( const QString
 
     win->setCaption( text );
     win->setIcon( icon );
+#ifdef Q_WS_X11
     KWin::setIcons( win->winId(), icon, icon );
+#endif
 }
 
 void KWindowInfo::save()
 {
+#ifdef Q_WS_X11
     if ( !oldText.isNull() )
 	return;
 
@@ -143,6 +147,7 @@ void KWindowInfo::save()
 	else
 	    oldIcon.resize( 0, 0 );
     }
+#endif
 }
 
 void KWindowInfo::restore()
@@ -156,7 +161,9 @@ void KWindowInfo::restore()
     }
 
     win->setIcon( oldIcon );
+#ifdef Q_WS_X11
     KWin::setIcons( win->winId(), oldIcon, oldMiniIcon );
+#endif
     win->setCaption( oldText );
     oldText = QString::null;
 
Index: kdeui/kwindowlistmenu.cpp
===================================================================
RCS file: /home/kde/kdelibs/kdeui/kwindowlistmenu.cpp,v
retrieving revision 1.14
diff -d -u -p -r1.14 kwindowlistmenu.cpp
--- kdeui/kwindowlistmenu.cpp	18 Feb 2003 03:19:49 -0000	1.14
+++ kdeui/kwindowlistmenu.cpp	5 Mar 2003 05:57:55 -0000
@@ -28,7 +28,7 @@ CONNECTION WITH THE SOFTWARE OR THE USE 
 #include <kwinmodule.h>
 #include <klocale.h>
 #include <kstringhandler.h>
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
 #include <netwm.h>
 #endif
 #include <kapplication.h>
@@ -51,7 +51,7 @@ private:
 
 int NameSortedInfoList::compareItems( QPtrCollection::Item s1, QPtrCollection::Item s2 )
 {
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11 //FIXME
     KWin::Info *i1 = static_cast<KWin::Info *>(s1);
     KWin::Info *i2 = static_cast<KWin::Info *>(s2);
     QString title1, title2;
@@ -60,14 +60,19 @@ int NameSortedInfoList::compareItems( QP
     if (i2)
         title2 = i2->visibleNameWithState().lower();
     return title1.compare(title2);
+#else
+    //FIXME: Implement (QWS & MAC) 
 #endif
+    return 0;
 }
 
 KWindowListMenu::KWindowListMenu(QWidget *parent, const char *name)
   : KPopupMenu(parent, name)
 {
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11
     kwin_module = new KWinModule(this);
+#else
+    //FIXME: Implement (QWS & MAC) 
 #endif
 
     connect(this, SIGNAL(activated(int)), SLOT(slotExec(int)));
@@ -83,7 +88,7 @@ void KWindowListMenu::init()
     int i, d;
     i = 0;
 
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11
     int nd = kwin_module->numberOfDesktops();
     int cd = kwin_module->currentDesktop();
     WId active_window = kwin_module->activeWindow();
@@ -137,17 +142,21 @@ void KWindowListMenu::init()
         if (d < nd)
             insertSeparator();
     }
+#else
+    //FIXME: Implement (QWS & MAC) 
 #endif
     adjustSize();
 }
 
 void KWindowListMenu::slotExec(int id)
 {
-#ifndef Q_WS_QWS //FIXME
+#ifdef Q_WS_X11
     if (id > 1000)
         KWin::setCurrentDesktop(id - 1000);
     else if ( id >= 0 )
 	KWin::setActiveWindow(map[id]);
+#else
+    //FIXME: Implement (QWS & MAC) 
 #endif
 }
 
Index: kdeui/qxembed.h
===================================================================
RCS file: /home/kde/kdelibs/kdeui/qxembed.h,v
retrieving revision 1.15
diff -d -u -p -r1.15 qxembed.h
--- kdeui/qxembed.h	22 Feb 2003 02:35:10 -0000	1.15
+++ kdeui/qxembed.h	5 Mar 2003 05:57:56 -0000
@@ -24,7 +24,7 @@
 
 #include <qwidget.h>
 
-#ifndef Q_WS_QWS
+#if !defined( Q_WS_QWS ) && !defined( Q_WS_MAC )
 
 /*
   Documentation for this class is in the cpp-file!
Index: khtml/ecma/kjs_window.cpp
===================================================================
RCS file: /home/kde/kdelibs/khtml/ecma/kjs_window.cpp,v
retrieving revision 1.327
diff -d -u -p -r1.327 kjs_window.cpp
--- khtml/ecma/kjs_window.cpp	27 Feb 2003 22:42:51 -0000	1.327
+++ khtml/ecma/kjs_window.cpp	5 Mar 2003 05:58:10 -0000
@@ -130,7 +130,9 @@ Value Screen::get(ExecState *exec, const
 
 Value Screen::getValueProperty(ExecState *exec, int token) const
 {
+#ifdef Q_WS_X11
   KWinModule info;
+#endif
   QWidget *thisWidget = Window::retrieveActive(exec)->part()->view();
   QRect sg = KGlobalSettings::desktopGeometry(thisWidget);
 
@@ -145,20 +147,36 @@ Value Screen::getValueProperty(ExecState
     return Number(m.depth());
   }
   case AvailLeft: {
+#ifdef Q_WS_X11
     QRect clipped = info.workArea().intersect(sg);
     return Number(clipped.x()-sg.x());
+#else
+    return Number(sg.x());
+#endif
   }
   case AvailTop: {
+#ifdef Q_WS_X11
     QRect clipped = info.workArea().intersect(sg);
     return Number(clipped.y()-sg.y());
+#else
+    return Number(sg.y());
+#endif
   }
   case AvailHeight: {
+#ifdef Q_WS_X11
     QRect clipped = info.workArea().intersect(sg);
     return Number(clipped.height());
+#else
+    return Number(sg.height());
+#endif
   }
   case AvailWidth: {
+#ifdef Q_WS_X11
     QRect clipped = info.workArea().intersect(sg);
     return Number(clipped.width());
+#else
+    return Number(sg.width());
+#endif
   }
   default:
     kdWarning(6070) << "Screen::getValueProperty unhandled token " << token << endl;
@@ -522,9 +540,15 @@ Value Window::get(ExecState *exec, const
     {
       if (!m_part->widget())
         return Number(0);
+#ifdef Q_WS_X11
       KWin::Info inf = KWin::info(m_part->widget()->topLevelWidget()->winId());
       return Number(entry->value == OuterHeight ?
                     inf.geometry.height() : inf.geometry.width());
+#else
+      return Number(entry->value == OuterHeight ?
+                    m_part->widget()->topLevelWidget()->height() : 
+                    m_part->widget()->topLevelWidget()->width());
+#endif
     }
     case PageXOffset:
       return Number(m_part->view()->contentsX());
Index: khtml/java/javaembed.h
===================================================================
RCS file: /home/kde/kdelibs/khtml/java/javaembed.h,v
retrieving revision 1.9
diff -d -u -p -r1.9 javaembed.h
--- khtml/java/javaembed.h	17 Jun 2002 22:09:50 -0000	1.9
+++ khtml/java/javaembed.h	5 Mar 2003 05:58:10 -0000
@@ -28,7 +28,7 @@
 
 #include <qwidget.h>
 
-#ifndef Q_WS_QWS // FIXME(E)? I don't think this is possible with Qt Embedded.
+#ifdef Q_WS_X11
 class KJavaEmbedPrivate;
 class KJavaEmbed : public QWidget
 {
@@ -72,6 +72,7 @@ private:
     void sendSyntheticConfigureNotifyEvent();
 };
 
-
+#else
+// FIXME: Implement in QWS & MAC
 #endif
 #endif
Index: khtml/java/kjavaappletwidget.cpp
===================================================================
RCS file: /home/kde/kdelibs/khtml/java/kjavaappletwidget.cpp,v
retrieving revision 1.53
diff -d -u -p -r1.53 kjavaappletwidget.cpp
--- khtml/java/kjavaappletwidget.cpp	27 Feb 2003 18:15:43 -0000	1.53
+++ khtml/java/kjavaappletwidget.cpp	5 Mar 2003 05:58:10 -0000
@@ -28,7 +28,6 @@
 
 #include <qlabel.h>
 
-
 // For future expansion
 class KJavaAppletWidgetPrivate
 {
@@ -43,11 +42,15 @@ KJavaAppletWidget::KJavaAppletWidget( KJ
                                       QWidget* parent, const char* name )
    : QXEmbed ( parent, name)
 {
+#ifdef Q_WS_X11
     setProtocol(QXEmbed::XPLAIN);
+#endif
 
     m_applet = new KJavaApplet( this, context );
     d        = new KJavaAppletWidgetPrivate;
+#ifdef Q_WS_X11
     m_kwm    = new KWinModule( this );
+#endif
 
     d->tmplabel = new QLabel( this );
     d->tmplabel->setText( KJavaAppletServer::getAppletLabel() );
@@ -67,10 +70,12 @@ KJavaAppletWidget::~KJavaAppletWidget()
 
 void KJavaAppletWidget::showApplet()
 {
+#ifdef Q_WS_X11
     connect( m_kwm, SIGNAL( windowAdded( WId ) ),
 	         this,  SLOT( setWindow( WId ) ) );
 
     m_kwm->doNotManage( m_swallowTitle );
+#endif
 
     //Now we send applet info to the applet server
     if ( !m_applet->isCreated() )
@@ -79,6 +84,7 @@ void KJavaAppletWidget::showApplet()
 
 void KJavaAppletWidget::setWindow( WId w )
 {
+#ifdef Q_WS_X11
     //make sure that this window has the right name, if so, embed it...
     KWin::Info w_info = KWin::info( w );
     if ( m_swallowTitle == w_info.name ||
@@ -97,6 +103,7 @@ void KJavaAppletWidget::setWindow( WId w
         embed( w );
         setFocus();
     }
+#endif
 }
 
 QSize KJavaAppletWidget::sizeHint() const
Index: khtml/java/kjavaappletwidget.h
===================================================================
RCS file: /home/kde/kdelibs/khtml/java/kjavaappletwidget.h,v
retrieving revision 1.34
diff -d -u -p -r1.34 kjavaappletwidget.h
--- khtml/java/kjavaappletwidget.h	27 Feb 2003 18:15:43 -0000	1.34
+++ khtml/java/kjavaappletwidget.h	5 Mar 2003 05:58:10 -0000
@@ -25,10 +25,12 @@
 #define KJAVAAPPLETWIDGET_H
 
 #include <qwidget.h>
-#ifndef Q_WS_QWS //FIXME(?) I don't think this is possible with Qt Embedded
+#ifndef Q_WS_QWS
 #include "java/kjavaappletcontext.h"
 #include "java/kjavaapplet.h"
-#include <qxembed.h>
+#ifdef Q_WS_X11
+# include <qxembed.h>
+#endif
 #include <kwinmodule.h>
 
 /**
@@ -75,6 +77,10 @@
 
 class KJavaAppletWidgetPrivate;
 
+#ifndef Q_WS_X11
+# define QXEmbed QWidget
+#endif
+
 class KJavaAppletWidget : public QXEmbed
 {
     Q_OBJECT
@@ -115,11 +121,15 @@ private:
     KJavaAppletWidgetPrivate* d;
 
     KJavaApplet* m_applet;
+#ifdef Q_WS_X11
     KWinModule*  m_kwm;
+#endif
     QString      m_swallowTitle;
 
 };
 
+#else
+// FIXME: Implement in QWS
 #endif
 #endif // KJAVAAPPLETWIDGET_H
 
Index: kinit/kinit.cpp
===================================================================
RCS file: /home/kde/kdelibs/kinit/kinit.cpp,v
retrieving revision 1.116
diff -d -u -p -r1.116 kinit.cpp
--- kinit/kinit.cpp	25 Feb 2003 08:40:39 -0000	1.116
+++ kinit/kinit.cpp	5 Mar 2003 05:58:13 -0000
@@ -37,7 +37,9 @@
 
 #include <errno.h>
 #include <fcntl.h>
-#include <setproctitle.h>
+#ifndef Q_WS_MAC
+# include <setproctitle.h>
+#endif
 #include <signal.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -105,6 +107,8 @@ static Atom net_current_desktop;
 #define DISPLAY "DISPLAY"
 #elif defined(Q_WS_QWS)
 #define DISPLAY "QWS_DISPLAY"
+#elif defined(Q_WS_MAC)
+//we don't use DISPLAY on Qt/Mac !! --Sam
 #else
 #error Use QT/X11 or QT/Embedded
 #endif
@@ -190,8 +194,10 @@ static void close_fds()
    }
 #endif
 
+#ifndef Q_WS_MAC
    signal(SIGCHLD, SIG_DFL);
    signal(SIGPIPE, SIG_DFL);
+#endif
 }
 
 static void exitWithErrorMsg(const QString &errorMsg)
@@ -401,7 +407,11 @@ static pid_t launch(int argc, const char
 #endif
 
   d.errorMsg = 0;
+#ifdef Q_WS_MAC
   d.fork = fork();
+#else
+  d.fork = vfork();
+#endif
   switch(d.fork) {
   case -1:
      perror("kdeinit: fork() failed!\n");
@@ -474,8 +484,10 @@ static pid_t launch(int argc, const char
        }
        d.argv[argc] = 0;
 
+#ifndef Q_WS_MACX
        /** Give the process a new name **/
        kdeinit_setproctitle( "%s", procTitle.data() );
+#endif
      }
 
      d.handle = 0;
@@ -868,6 +880,11 @@ static int read_socket(int sock, char *b
 
 static void WaitPid( pid_t waitForPid)
 {
+#ifdef QT_MAC
+    /* right now I need this because apps don't run with fork mode on right now!! I will
+       remove this when I fix that! */
+    return;
+#endif
   int result;
   while(1)
   {
@@ -1003,23 +1020,31 @@ static void handle_launcher_request(int 
      }
 
       // support for the old a bit broken way of setting DISPLAY for multihead
+#ifndef Q_WS_MAC
       QCString olddisplay = getenv(DISPLAY);
+#else
+      QCString olddisplay = "0";
+#endif
       QCString kdedisplay = getenv("KDE_DISPLAY");
       bool reset_display = (! olddisplay.isEmpty() &&
                             ! kdedisplay.isEmpty() &&
                             olddisplay != kdedisplay);
 
+#ifndef Q_WS_MAC
       if (reset_display)
           setenv(DISPLAY, kdedisplay, true);
+#endif
 
       pid = launch( argc, name, args, cwd, envc, envs,
           request_header.cmd == LAUNCHER_SHELL || request_header.cmd == LAUNCHER_KWRAPPER,
           tty, avoid_loops, startup_id_str );
 
+#ifndef Q_WS_MAC
       if (reset_display) {
           unsetenv("KDE_DISPLAY");
           setenv(DISPLAY, olddisplay, true);
       }
+#endif
 
       if (pid && (d.result == 0))
       {
@@ -1204,8 +1229,13 @@ static void kdeinit_library_path()
 {
    QStringList ltdl_library_path =
      QStringList::split(':', QFile::decodeName(getenv("LTDL_LIBRARY_PATH")));
+#ifndef Q_WS_MAC
    QStringList ld_library_path =
      QStringList::split(':', QFile::decodeName(getenv("LD_LIBRARY_PATH")));
+#else
+   QStringList ld_library_path =
+     QStringList::split(':', QFile::decodeName(getenv("DYLD_LIBRARY_PATH")));
+#endif
 
    QCString extra_path;
    QStringList candidates = s_instance->dirs()->resourceDirs("lib");
@@ -1247,6 +1277,7 @@ static void kdeinit_library_path()
    if (!extra_path.isEmpty())
       lt_dlsetsearchpath(extra_path.data());
 
+#ifndef Q_WS_MAC
    QCString display = getenv(DISPLAY);
    if (display.isEmpty())
    {
@@ -1256,6 +1287,9 @@ static void kdeinit_library_path()
    int i;
    if((i = display.findRev('.')) > display.findRev(':') && i >= 0)
      display.truncate(i);
+#else
+   const char *display = "0";
+#endif
 
    QCString socketName = QFile::encodeName(locateLocal("socket", QString("kdeinit-%1").arg(display), s_instance));
    if (socketName.length() >= MAX_SOCK_FILE)
@@ -1426,11 +1460,15 @@ int main(int argc, char **argv, char **e
    KGlobal::_instance = 0L;
 
    /** Prepare to change process name **/
+#ifndef Q_WS_MAC
    kdeinit_initsetproctitle(argc, argv, envp);
    kdeinit_setproctitle("Starting up...");
+#endif
    kdeinit_library_path();
+#ifndef Q_WS_APPLE
    // don't change envvars before kdeinit_initsetproctitle()
    unsetenv("LD_BIND_NOW");
+#endif
    if (!suicide)
       setenv("KDE_FULL_SESSION", "true", true);
    KApplication::loadedByKdeinit = true;
@@ -1528,7 +1566,9 @@ int main(int argc, char **argv, char **e
    }
    free (safe_argv);
 
+#ifndef Q_WS_MAC
    kdeinit_setproctitle("Running...");
+#endif
 
    if (!keep_running)
       return 0;
Index: kinit/klauncher.cpp
===================================================================
RCS file: /home/kde/kdelibs/kinit/klauncher.cpp,v
retrieving revision 1.85
diff -d -u -p -r1.85 klauncher.cpp
--- kinit/klauncher.cpp	20 Feb 2003 15:35:09 -0000	1.85
+++ kinit/klauncher.cpp	5 Mar 2003 05:58:15 -0000
@@ -742,9 +742,13 @@ KLauncher::requestStart(KLaunchRequest *
       length += (*it).length() + 1; // Envs...
    }
    length += sizeof( long ); // avoid_loops
+#ifdef Q_WS_X11 
    bool startup_notify = !request->startup_id.isNull() && request->startup_id != "0";
    if( startup_notify )
        length += request->startup_id.length() + 1;
+#else
+   bool startup_notify = FALSE;
+#endif
        
    requestData.resize( length );
 
@@ -774,11 +778,13 @@ KLauncher::requestStart(KLaunchRequest *
    l = 0; // avoid_loops, always false here
    memcpy(p, &l, sizeof(long));
    p += sizeof(long);
+#ifdef Q_WS_X11 
    if( startup_notify )
    {
        strcpy(p, request->startup_id.data());
        p += strlen( p ) + 1;
    }
+#endif
    request_header.cmd = startup_notify ? LAUNCHER_EXT_EXEC : LAUNCHER_EXEC_NEW;
    request_header.arg_length = length;
    write(kdeinitSocket, &request_header, sizeof(request_header));
@@ -1087,7 +1093,9 @@ KLauncher::kdeinit_exec(const QString &a
       request->dcop_service_type = KService::DCOP_None;
    request->dcop_name = 0;
    request->pid = 0;
+#ifdef Q_WS_X11 
    request->startup_id = "0";
+#endif
    request->envs = envs;
    request->transaction = dcopClient()->beginTransaction();
    queueRequest(request);
@@ -1224,7 +1232,9 @@ KLauncher::requestSlave(const QString &p
     request->dcop_name = 0;
     request->dcop_service_type = KService::DCOP_None;
     request->pid = 0;
+#ifdef Q_WS_X11 
     request->startup_id = "0";
+#endif
     request->status = KLaunchRequest::Launching;
     request->transaction = 0; // No confirmation is send
     requestStart(request);
Index: kio/kio/kprotocolmanager.cpp
===================================================================
RCS file: /home/kde/kdelibs/kio/kio/kprotocolmanager.cpp,v
retrieving revision 1.126
diff -d -u -p -r1.126 kprotocolmanager.cpp
--- kio/kio/kprotocolmanager.cpp	28 Feb 2003 21:40:01 -0000	1.126
+++ kio/kio/kprotocolmanager.cpp	5 Mar 2003 05:58:16 -0000
@@ -428,7 +428,17 @@ QString KProtocolManager::defaultUserAge
     }
     if( modifiers.contains('p') )
     {
-      supp += QString::fromLatin1("; X11");  // TODO: determine this valye instead of hardcoding...
+#ifdef Q_WS_X11
+      supp += QString::fromLatin1("; X11");
+#elif defined(Q_WS_MACX)
+      supp += QString::fromLatin1("; Mac OS X");
+#elif defined(Q_WS_QWS)
+      supp += QString::fromLatin1("; Embedded");
+#elif defined(Q_WS_WIN)
+      supp += QString::fromLatin1("; Windows");
+#else
+      supp += QString::fromLatin1("; Unknown");
+#endif
     }
     if( modifiers.contains('m') )
     {
Index: kio/kio/kzip.cpp
===================================================================
RCS file: /home/kde/kdelibs/kio/kio/kzip.cpp,v
retrieving revision 1.30
diff -d -u -p -r1.30 kzip.cpp
--- kio/kio/kzip.cpp	28 Feb 2003 21:40:01 -0000	1.30
+++ kio/kio/kzip.cpp	5 Mar 2003 05:58:18 -0000
@@ -38,6 +38,9 @@
 */
 
 #include <sys/time.h>
+#ifdef HAVE_ALLOC_H
+# include <alloca.h>
+#endif
 #include <stdlib.h>
 
 #include <qasciidict.h>
